local bs = AceLibrary("Babble-Spell-2.2")
local AceAddon = AceLibrary("AceAddon-2.0")
local Tablet = AceLibrary("Tablet-2.0")

local L = AceLibrary("AceLocale-2.2"):new("Cartographer_Mining")
L:RegisterTranslations("enUS", function() return {
	["Filter"] = true,
	["Filter out minerals"] = true,
	
	["Select all"] = true,
	["Select none"] = true,
	
	["Copper"] = true,
	["Tin"] = true,
	["Iron"] = true,
	["Silver"] = true,
	["Gold"] = true,
	["Mithril"] = true,
	["Truesilver"] = true,
	["Thorium"] = true,
	["Rich Thorium"] = true,
	["Dark Iron"] = true,
	-- tbc
	["Fel Iron"] = true,
	["Adamantite"] = true,
	["Rich Adamantite"] = true,
	["Khorium"] = true,
	
	["Copper Vein"] = true,
	["Tin Vein"] = true,
	["Iron Deposit"] = true,
	["Silver Vein"] = true,
	["Ooze Covered Silver Vein"] = true,
	["Gold Vein"] = true,
	["Ooze Covered Gold Vein"] = true,
	["Mithril Deposit"] = true,
	["Ooze Covered Mithril Deposit"] = true,
	["Truesilver Deposit"] = true,
	["Ooze Covered Truesilver Deposit"] = true,
	["Small Thorium Vein"] = true,
	["Ooze Covered Thorium Vein"] = true,
	["Hakkari Thorium Vein"] = true,
	["Rich Thorium Vein"] = true,
	["Ooze Covered Rich Thorium Vein"] = true,
	["Dark Iron Deposit"] = true,
	-- tbc
	["Fel Iron Deposit"] = true,
	["Adamantite Deposit"] = true,
	["Rich Adamantite Deposit"] = true,
	["Khorium Vein"] = true,
	
} end)

L:RegisterTranslations("deDE", function() return {
	["Filter"] = "Filter",
	["Filter out minerals"] = "Filtere Mineralien",
	
	["Select all"] = "Alle auswahlen",
	["Select none"] = "Nichts ausahlen",

	["Copper"] = "Kupfer",
	["Tin"] = "Zinn",
	["Iron"] = "Eisen",
	["Silver"] = "Silber",
	["Gold"] = "Gold",
	["Mithril"] = "Mithril",
	["Truesilver"] = "Echtsilber",
	["Thorium"] = "Thorium",
	["Rich Thorium"] = "Reiches Thorium",
	["Dark Iron"] = "Dunkeleisen",
	-- tbc
	["Fel Iron"] = "Teufelseisen", -- check
	["Adamantite"] = "Adamantium", -- check
	["Rich Adamantite"] = "Reiches Adamantium", -- check
	["Khorium"] = "Khorium", -- check
	
	["Copper Vein"] = "Kupfervorkommen",
	["Tin Vein"] = "Zinnvorkommen",
	["Iron Deposit"] = "Eisenvorkommen",
	["Silver Vein"] = "Silbervorkommen",
	["Ooze Covered Silver Vein"] = "Br\195\188hschlammbedecktes Silbervorkommen",
	["Gold Vein"] = "Goldvorkommen",
	["Ooze Covered Gold Vein"] = "Br\195\188hschlammbedecktes Goldvorkommen",
	["Mithril Deposit"] = "Mithrilablagerung",
	["Ooze Covered Mithril Deposit"] = "Br\195\188hschlammbedeckte Mithrilablagerung",
	["Truesilver Deposit"] = "Echtsilberablagerung",
	["Ooze Covered Truesilver Deposit"] = "Br\195\188hschlammbedeckte Echtsilberablagerung",
	["Small Thorium Vein"] = "Kleines Thoriumvorkommen",
	["Ooze Covered Thorium Vein"] = "Br\195\188hschlammbedecktes Thoriumvorkommen",
	["Hakkari Thorium Vein"] = "Hakkari Thoriumvorkommen",
	["Rich Thorium Vein"] = "Reiches Thoriumvorkommen",
	["Ooze Covered Rich Thorium Vein"] = "Br\195\188hschlammbedecktes reiches Thoriumvorkommen",
	["Dark Iron Deposit"] = "Dunkeleisenablagerung",
	-- tbc
	["Fel Iron Deposit"] = "Teufelseisenvorkommen",
	["Adamantite Deposit"] = "Adamantitablagerung",
	["Rich Adamantite Deposit"] = "Reiche Adamantitablagerung", -- check
	["Khorium Vein"] = "Khoriumvorkommen",
	
} end)

L:RegisterTranslations("frFR", function() return {
--	["Filter"] = true,
--	["Filter out minerals"] = true,
	
--	["Select all"] = true,
--	["Select none"] = true,

--	["Copper"] = true,
--	["Tin"] = true,
--	["Iron"] = true,
--	["Silver"] = true,
--	["Gold"] = true,
--	["Mithril"] = true,
--	["Truesilver"] = true,
--	["Thorium"] = true,
--	["Rich Thorium"] = true,
--	["Dark Iron"] = true,
--	["Fel Iron"] = true,
--	["Adamantite"] = true,
--	["Rich Adamantite"] = true,
--	["Khorium"] = true,
	
	["Copper Vein"] = "Filon de cuivre",
	["Tin Vein"] = "Filon d'etain",
	["Iron Deposit"] = "Gisement de fer",
	["Silver Vein"] = "Filon d'argent",
--	["Ooze Covered Silver Vein"] = true,
	["Gold Vein"] = "Filon d'or",
--	["Ooze Covered Gold Vein"] = true,
	["Mithril Deposit"] = "Gisement de mithril",
	["Ooze Covered Mithril Deposit"] = "Gisement de mithril couvert de vase",
	["Truesilver Deposit"] = "Gisement de vrai-argent",
	["Ooze Covered Truesilver Deposit"] = "Gisement de vrai-argent couvert de vase",
	["Small Thorium Vein"] = "Petit filon de thorium",
	["Ooze Covered Thorium Vein"] = "Filon de thorium couvert de limon",
	["Hakkari Thorium Vein"] = "Filon de thorium Hakkari",
	["Rich Thorium Vein"] = "Riche filon de thorium",
	["Ooze Covered Rich Thorium Vein"] = "Riche filon de thorium couvert de limon",
	["Dark Iron Deposit"] = "Gisement de sombrefer",
--	["Fel Iron Deposit"] = true,
} end)

L:RegisterTranslations("esES", function() return {
	["Filter"] = "Filtro",
	["Filter out minerals"] = "Filtrar minerales",
	
	["Select all"] = "Seleccionar todo",
	["Select none"] = "No seleccionar nada",

	["Copper"] = "Cobre",
	["Tin"] = "Esta\195\177o",
	["Iron"] = "Hierro",
	["Silver"] = "Plata",
	["Gold"] = "Oro",
	["Mithril"] = "Mitril",
	["Truesilver"] = "Veraplata",
	["Thorium"] = "Torio",
--	["Rich Thorium"] = true,
	["Dark Iron"] = "Hierro negro",
--	["Fel Iron"] = true,
--	["Adamantite"] = true,
--	["Rich Adamantite"] = true,
--	["Khorium"] = true,

	["Copper Vein"] = "Fil\195\179n de cobre",
	["Tin Vein"] = "Fil\195\179n de esta\195\177o",
	["Iron Deposit"] = "Dep\195\179sito de hierro",
	["Silver Vein"] = "Fil\195\179n de plata",
--	["Ooze Covered Silver Vein"] = true,
	["Gold Vein"] = "Fil\195\179n de oro",
--	["Ooze Covered Gold Vein"] = true,
	["Mithril Deposit"] = "Dep\195\179sito de mitril",
--	["Ooze Covered Mithril Deposit"] = true,
	["Truesilver Deposit"] = "Dep\195\179sito de veraplata",
--	["Ooze Covered Truesilver Deposit"] = true,
	["Small Thorium Vein"] = "Fil\195\179n pequeno de torio",
--	["Ooze Covered Thorium Vein"] = true,
--	["Hakkari Thorium Vein"] = true,
	["Rich Thorium Vein"] = "Fil\195\179n de torio enriquecido",
--	["Ooze Covered Rich Thorium Vein"] = true,
	["Dark Iron Deposit"] = "Dep\195\179sito de los Hierro Negro",
--	["Fel Iron Deposit"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Filter"] = "필터링",
	["Filter out minerals"] = "광맥에 따라서 지도에 표시 여부를 선택합니다.",

	["Select all"] = "모두 선택",
	["Select none"] = "선택 해제",

	["Copper"] = "구리",
	["Tin"] = "주석",
	["Iron"] = "철",
	["Silver"] = "은",
	["Gold"] = "금",
	["Mithril"] = "미스릴",
	["Truesilver"] = "진은",
	["Thorium"] = "토륨",
	["Rich Thorium"] = "풍부한 토륨",
	["Dark Iron"] = "검은무쇠",
	["Fel Iron"] = "지옥무쇠",
	["Adamantite"] = "아다만타이트",
	["Rich Adamantite"] = "풍부한 아다만타이트",
	["Khorium"] = "코륨",
	
	["Copper Vein"] = "구리 광맥",
	["Tin Vein"] = "주석 광맥",
	["Iron Deposit"] = "철 광맥",
	["Silver Vein"] = "은 광맥",
	["Ooze Covered Silver Vein"] = "진흙으로 덮인 은 광맥",
	["Gold Vein"] = "금 광맥",
	["Ooze Covered Gold Vein"] = "진흙으로 덮인 금 광맥",
	["Mithril Deposit"] = "미스릴 광맥",
	["Ooze Covered Mithril Deposit"] = "진흙으로 덮인 미스릴 광맥",
	["Truesilver Deposit"] = "진은 광맥",
	["Ooze Covered Truesilver Deposit"] = "진흙으로 덮인 진은 광맥",
	["Small Thorium Vein"] = "작은 토륨 광맥",
	["Ooze Covered Thorium Vein"] = "진흙으로 덮인 토륨 광맥",
	["Hakkari Thorium Vein"] = "학카리 토륨 광맥",
	["Rich Thorium Vein"] = "풍부한 토륨 광맥",
	["Ooze Covered Rich Thorium Vein"] = "진흙으로 덮인 풍부한 토륨 광맥",
	["Dark Iron Deposit"] = "검은무쇠 광맥",
	["Fel Iron Deposit"] = "지옥무쇠 광맥",
} end)

L:RegisterTranslations("zhTW", function() return {
	["Filter"] = "篩檢",
	["Filter out minerals"] = "篩檢?石",
	
	["Select all"] = "全部選擇",
	["Select none"] = "全部取消",

	["Copper"] = "銅",
	["Tin"] = "錫",
	["Iron"] = "鐵",
	["Silver"] = "銀",
	["Gold"] = "金",
	["Mithril"] = "秘銀",
	["Truesilver"] = "?銀",
	["Thorium"] = "瑟銀",
	["Rich Thorium"] = "富瑟銀",
	["Dark Iron"] = "黑鐵",
	--["Fel Iron"] = true,
	--["Adamantite"] = true,
	--["Rich Adamantite"] = true,
	--["Khorium"] = true,
	
--	["Copper Vein"] = true,
--	["Tin Vein"] = true,
--	["Iron Deposit"] = true,
--	["Silver Vein"] = true,
--	["Ooze Covered Silver Vein"] = true,
--	["Gold Vein"] = true,
--	["Ooze Covered Gold Vein"] = true,
--	["Mithril Deposit"] = true,
--	["Ooze Covered Mithril Deposit"] = true,
--	["Truesilver Deposit"] = true,
--	["Ooze Covered Truesilver Deposit"] = true,
--	["Small Thorium Vein"] = true,
--	["Ooze Covered Thorium Vein"] = true,
--	["Hakkari Thorium Vein"] = true,
--	["Rich Thorium Vein"] = true,
--	["Ooze Covered Rich Thorium Vein"] = true,
--	["Dark Iron Deposit"] = true,
--	["Fel Iron Deposit"] = true,
} end)

L:RegisterTranslations("zhCN", function() return {
--	["Filter"] = true,
--	["Filter out minerals"] = true,
	
--	["Select all"] = true,
--	["Select none"] = true,

--	["Copper"] = true,
--	["Tin"] = true,
--	["Iron"] = true,
--	["Silver"] = true,
--	["Gold"] = true,
--	["Mithril"] = true,
--	["Truesilver"] = true,
--	["Thorium"] = true,
--	["Rich Thorium"] = true,
--	["Dark Iron"] = true,
--	["Fel Iron"] = true,
--	["Adamantite"] = true,
--	["Rich Adamantite"] = true,
--	["Khorium"] = true,
	
	["Copper Vein"] = "??",
	["Tin Vein"] = "??",
	["Iron Deposit"] = "??石",
	["Silver Vein"] = "??",
--	["Ooze Covered Silver Vein"] = true,
--	["Gold Vein"] = true,
--	["Ooze Covered Gold Vein"] = true,
	["Mithril Deposit"] = "秘???",
--	["Ooze Covered Mithril Deposit"] = true,
	["Truesilver Deposit"] = "???石",
--	["Ooze Covered Truesilver Deposit"] = true,
	["Small Thorium Vein"] = "瑟???",
--	["Ooze Covered Thorium Vein"] = true,
	["Hakkari Thorium Vein"] = "哈??瑟???",
	["Rich Thorium Vein"] = "富瑟??",
--	["Ooze Covered Rich Thorium Vein"] = true,
--	["Dark Iron Deposit"] = true,
--	["Fel Iron Deposit"] = true,
} end)

local mod = Cartographer:NewModule(bs["Mining"], "AceConsole-2.0", "AceEvent-2.0")

mod.icon = {
	["Copper"] = {
		text = L["Copper"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Copper_01",
		width = 14,
		height = 14
	},
	["Tin"] = {
		text = L["Tin"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Tin_01",
		width = 14,
		height = 14
	},
	["Silver"] = {
		text = L["Silver"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Stone_16",
		width = 14,
		height = 14
	},
	["Iron"] = {
		text = L["Iron"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Iron_01",
		width = 14,
		height = 14
	},
	["Gold"] = {
		text = L["Gold"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Copper_01",
		width = 14,
		height = 14
	},
	["Mithril"] = {
		text = L["Mithril"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Mithril_02",
		width = 14,
		height = 14
	},
	["Truesilver"] = {
		text = L["Truesilver"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_TrueSilver_01",
		width = 14,
		height = 14
	},
	["Thorium"] = {
		text = L["Thorium"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Thorium_02",
		width = 14,
		height = 14
	},
	["Rich Thorium"] = {
		text = L["Rich Thorium"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Thorium_02",
		width = 14,
		height = 14
	},
	["Dark Iron"] = {
		text = L["Dark Iron"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Mithril_02",
		width = 14,
		height = 14
	},
	["Fel Iron"] = {
		text = L["Fel Iron"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_FelIron",
		width = 14,
		height = 14
	},
	["Adamantite"] = {
		text = L["Adamantite"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Adamantium",
		width = 14,
		height = 14
	},
	["Rich Adamantite"] = {
		text = L["Rich Adamantite"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Adamantium_01",
		width = 14,
		height = 14
	},
	["Khorium"] = {
		text = L["Khorium"],
		path = "Interface\\AddOns\\Cartographer_Mining\\Artwork\\INV_Ore_Khorium",
		width = 14,
		height = 14
	}, 
}

function mod:OnInitialize()
	self.db = Cartographer:AcquireDBNamespace("Mining")
	Cartographer:RegisterDefaults("Mining", "profile", {
		filter = {
			['*'] = true,
		}
	})

	local aceopts = {}
	aceopts.toggle = {
		name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Enabled"],
		desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Suspend/resume this module."],
		type  = 'toggle',
		order = -1,
		get   = function() return Cartographer:IsModuleActive(self) end,
		set   = function() Cartographer:ToggleModuleActive(self) end,
	}

	aceopts.filter = {
		name = L["Filter"],
		desc = L["Filter out minerals"],
		type = 'group',
		args = {
			all = {
				name = L["Select all"],
				desc = L["Select all"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingMineral(k, true)
					end
				end,
				order = 1,
			},
			none = {
				name = L["Select none"],
				desc = L["Select none"],
				type = 'execute',
				func = function()
					for k in pairs(self.icon) do
						self:ToggleShowingMineral(k, false)
					end
				end,
				order = 2,
			},
			blank = {
				type = 'header',
				order = 3,
			}
		}
	}
	for k,v in pairs(self.icon) do
		local k = k
		aceopts.filter.args[k] = {
			name = v.text,
			desc = v.text,
			type = 'toggle',
			get = function()
				return self:IsShowingMineral(k)
			end,
			set = function(value)
				return self:ToggleShowingMineral(k, value)
			end,
		}
	end

	Cartographer.options.args[bs["Mining"]] = {
		name = bs["Mining"],
		desc = self.notes,
		type = 'group',
		args = aceopts,
		handler = self,
	}
	Cartographer:GetModule('Professions').addons[bs["Mining"]] = self
	AceLibrary("AceConsole-2.0"):InjectAceOptionsTable(self, Cartographer.options.args[bs["Mining"]])

	if not Cartographer_MiningDB then
		Cartographer_MiningDB = {}
	else
		for _, zone in pairs(Cartographer_MiningDB) do
			if type(zone) == "table" then
				for id, data in pairs(zone) do
					if data == "Small Thorium" then
						data = "Thorium"
						zone[id] = data
					end
				end
			end
		end
	end
end

function mod:OnEnable()
	if Cartographer_Notes then
		if not self.iconsregistered then
			for k,v in pairs(self.icon) do
				Cartographer_Notes:RegisterIcon(k, v)
			end
			self.iconsregistered = true
		end

		Cartographer_Notes:RegisterNotesDatabase('Mining', Cartographer_MiningDB, self)
	else
		Cartographer:ToggleModuleActive(self, false)
	end

	self:RegisterEvent("UI_ERROR_MESSAGE")

	self:RegisterEvent("CHAT_MSG_SPELL_SELF_BUFF")
end

function mod:OnDisable()
	self:UnregisterAllEvents()

	if Cartographer_Notes then
		Cartographer_Notes:UnregisterNotesDatabase('Mining')
	end
end

function mod:SetNote(what)
	local x, y = GetPlayerMapPosition("player")
	if x == 0 and y == 0 then return end
	local zone = GetRealZoneText()
	for zone, x_p, y_p, icon, creator, data in Cartographer_Notes:IterateNearbyNotes(zone, x, y, 8, "Mining", nil, true) do
		if icon == what then
			Cartographer_Notes:DeleteNote(zone, x_p, y_p)
		end
	end
	Cartographer_Notes:SetNote(zone, x, y, what, "Mining")
end

function mod:OnNoteTooltipRequest(zone, id, mineral, minimap)
	Tablet:SetTitle(L[mineral])
	Tablet:SetTitleColor(0, 0.8, 0)
	
	if Cartographer_Notes:IsShowingCreator() and not minimap then
		Tablet:AddCategory(
			'columns', 2,
			'hideBlankLine', true
		):AddLine(
			'text', AceLibrary("AceLocale-2.2"):new("Cartographer-Notes")["Created by"],
			'text2', bs["Mining"]
		)
	end
end

local t = {
	[L["Copper Vein"]] = "Copper",
	[L["Tin Vein"]] = "Tin",
	[L["Iron Deposit"]] = "Iron",
	[L["Silver Vein"]] = "Silver",
	[L["Ooze Covered Silver Vein"]] = "Silver",
	[L["Gold Vein"]] = "Gold",
	[L["Ooze Covered Gold Vein"]] = "Gold",
	[L["Mithril Deposit"]] = "Mithril",
	[L["Ooze Covered Mithril Deposit"]] = "Mithril",
	[L["Truesilver Deposit"]] = "Truesilver",
	[L["Ooze Covered Truesilver Deposit"]] = "Truesilver",
	[L["Small Thorium Vein"]] = "Thorium",
	[L["Ooze Covered Thorium Vein"]] = "Thorium",
	[L["Hakkari Thorium Vein"]] = "Thorium",
	[L["Rich Thorium Vein"]] = "Rich Thorium",
	[L["Ooze Covered Rich Thorium Vein"]] = "Rich Thorium",
	[L["Dark Iron Deposit"]] = "Dark Iron",
	[L["Fel Iron Deposit"]] = "Fel Iron",
	[L["Adamantite Deposit"]] = "Adamantite",
	[L["Rich Adamantite Deposit"]] = "Rich Adamantite",
	[L["Khorium Vein"]] = "Khorium",
}

function mod:RegisterOre(what)
	if what and what:len() > 0 then
		what = what:gsub("^(.-) %(%d+%)$", "%1")
		local mineral = t[what]
		if mineral then
			self:SetNote(mineral)
		end
	end
end

local perform_string = '^' .. (SIMPLEPERFORMSELFOTHER:format(bs["Mining"], "%s"):gsub("([%(%)%.%*%+%-%[%]%?%^%$%%])", "%%%1"):gsub("%%%%s", "(.+)")) .. '$'
function mod:CHAT_MSG_SPELL_SELF_BUFF(msg)
	local what = msg:match(perform_string)
	if what then
		self:RegisterOre(what)
	end
end

function mod:UI_ERROR_MESSAGE(msg)
	if msg:find(UNIT_SKINNABLE_ROCK) then
		self:RegisterOre(GameTooltipTextLeft1:GetText())
	end
end

function mod:IsNoteHidden(zone, id, mineral)
	return not self.db.profile.filter[mineral]
end

function mod:IsShowingMineral(mineral)
	return self.db.profile.filter[mineral]
end

function mod:ToggleShowingMineral(mineral, value)
	if value == nil then
		value = not self.db.profile.filter[mineral]
	end
	self.db.profile.filter[mineral] = value

	Cartographer_Notes:RefreshMap()
end
